// \AvP[V
//    u@@@v@
// `֌W (graph.cpp)

#include "graph.h"
#include "common.h"

//-------------------------------------
// S Window ĕ`֐
VOID RedrawAllWindows(LPRECT lpRect,HWND hWnd,HWND hMdi1,HWND hMdi2,HWND hMdi3){

	InvalidateRect(hWnd,lpRect,TRUE);

	// MDI  redraw
	RedrawWindow(hMdi1,NULL,NULL,RDW_INVALIDATE|RDW_UPDATENOW);
	RedrawWindow(hMdi2,NULL,NULL,RDW_INVALIDATE|RDW_UPDATENOW);
	RedrawWindow(hMdi3,NULL,NULL,RDW_INVALIDATE|RDW_UPDATENOW);
}


//-------------------------------------
// XyNg`֐
VOID SpecPaint(HWND hWnd,DWORD fftPoint, double* lpdFftData
			   ,WAVEFORMATEX waveFmt,
			   DWORD waveDataSize,
			   HANDLE hdWaveFile, // t@CĂ NULL
			   DWORD childWidth,DWORD childHeight,
			   LONG scrX,LONG scrY, DWORD pos, 
			   DWORD widthRate,DWORD heightRate,
			   double adjustAmp,BOOL bLogX,BOOL bLogZ,long nZbase){
	
	// `peϐ
	HDC hDC,hBufDC;
	HPEN hPen,hOldPen;	  
	HBRUSH hOldBrush;
	HFONT hFont,hOldFont;
	TEXTMETRIC textMet; 
    HBITMAP HbBufBit;	 // ʗpobt@
	
	RECT rt;
	DWORD clientWidth,clientHeight; // NCAg̈̑傫
	
	double widthRate2,heightRate2; // 摜̊g嗦vZp
	
	// ۂ̃NCAg̈̑傫擾
	// childWidth,childHeight ͉zIȑ傫
	GetClientRect(hWnd,&rt);
    clientWidth = rt.right-rt.left;
	clientHeight = rt.bottom-rt.top;
	
	//@WAVE ̏
	DWORD  dwFftHeight,dwBlockNo;
	SHORT waveChn,waveBit; 
	LONG  waveRate;
	
	// Gpϐ
	LONG i,i2,dFreq;
	DWORD ix,iy;
	CHAR str[CHR_BUF];

	// ϐݒ	  
	waveChn=2; //`l(_~[p)
	
	if(hdWaveFile != NULL){
		waveChn = (SHORT)waveFmt.nChannels;	 // `l
		waveRate = (LONG)waveFmt.nSamplesPerSec; // [g
		waveBit = (SHORT)waveFmt.wBitsPerSample; // rbg
		dwBlockNo = waveDataSize/(fftPoint*waveChn*waveBit/8)+1; 	// vbN 
		dwFftHeight = fftPoint/2;	 // FFT f[^̍ (1 `l) 							   
	}
	
	// t[̑傫AʒuvZ
	// scrX,scrY  z`̈(childWidth,childHeight)
	// (ۂ)NCAg̈(clientWidth,clientHeight) ɑ΂ʒu
	DWORD frameWidth = DEFAULT_FFTPOINT*widthRate; // g@1 ̓̕
	DWORD frameHeight = DEFAULT_FFTPOINT/4*heightRate;  // g@1 ̓̍
	DWORD leftTopX = (childWidth-(frameWidth+2))/2 + scrX ; // g̍@́@x W
	DWORD leftTopY = (childHeight-(frameHeight+2+(8+frameHeight+2)*(waveChn-1)))/2  -12 +scrY; //  ́@y W
	

	// \摜̊g嗦̌vZ(t[̕ / f[^)
	// widthRate  1 ̎
	// 256 _̎ 128 _f[^ǂݍ frameWidth = 512 _
	// x4 ƂȂBl 512 _̎ x2 A 1024 _ x1 , 2048 _ x1/2
	widthRate2 = (double)frameWidth/((double)fftPoint/2);
	
	// cg嗦 ( = heightRate )
    heightRate2 = (double)heightRate;
	
	// `Jn 
	hDC = GetDC(hWnd);
	
	// ʃobt@̍쐬
	HbBufBit = CreateCompatibleBitmap(hDC,clientWidth,clientHeight);
	hBufDC = CreateCompatibleDC(hDC);
    SelectObject(hBufDC,HbBufBit);
	
	// wi
	hOldPen = (HPEN)SelectObject(hBufDC,GetStockObject(NULL_PEN));
    hOldBrush = (HBRUSH)SelectObject(hBufDC,GetStockObject(BLACK_BRUSH));
	Rectangle(hBufDC,-1,-1,clientWidth+2,clientHeight+2);
	SelectObject(hBufDC,hOldPen);
	SelectObject(hBufDC,hOldBrush);
	
	// t[`	
	hPen = CreatePen(PS_SOLID,1,RGB(255,255,255));
	hOldPen = (HPEN)SelectObject(hBufDC,hPen);
	hOldBrush = (HBRUSH)SelectObject(hBufDC,GetStockObject(NULL_BRUSH));
	
	// 
	Rectangle(hBufDC,leftTopX,leftTopY,
		leftTopX+frameWidth+2,leftTopY+frameHeight+2);
	// E
	if(waveChn==2)
		Rectangle(hBufDC,leftTopX,leftTopY+frameHeight+2+8,
		leftTopX+frameWidth+2,leftTopY+frameHeight+2+8+frameHeight+2);
	
	SelectObject(hBufDC,hOldPen);
	DeleteObject(hPen);
	SelectObject(hBufDC,hOldBrush);
	
	if(hdWaveFile == NULL){	  // t@CĂ
		
		// tHgݒ
		hFont=CreateFont(24,0,0,0,FW_NORMAL,FALSE,FALSE,FALSE,SHIFTJIS_CHARSET
			,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
			FIXED_PITCH|FF_MODERN,"lr ");
		hOldFont = (HFONT)SelectObject(hBufDC,hFont);	
		
		// gbN擾
		GetTextMetrics(hBufDC,&textMet);
		
		// `
		SetBkMode(hBufDC,TRANSPARENT);			 
        SetTextColor(hBufDC,RGB(255,255,0)) ;
		TextOut(hBufDC,leftTopX+(frameWidth-textMet.tmAveCharWidth*4)/2
			,leftTopY+(frameHeight-textMet.tmHeight)/2,"LEFT",4);
		TextOut(hBufDC,leftTopX+(frameWidth-textMet.tmAveCharWidth*5)/2
			,leftTopY+frameHeight+2+8+(frameHeight-textMet.tmHeight)/2,"RIGHT",5);
		
		SelectObject(hBufDC,hOldFont);			  
		DeleteObject(hFont);
		
	}
	else{ 	 // t@CJĂ
		
		// ڐ`
		// tHgI
		hFont=CreateFont(10,0,0,0,FW_NORMAL,FALSE,FALSE,FALSE,SHIFTJIS_CHARSET
			,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, 
			FIXED_PITCH|FF_MODERN,"lr ");		
		hOldFont = (HFONT)SelectObject(hBufDC,hFont);	 
		GetTextMetrics(hBufDC,&textMet);	   
		SetBkMode(hBufDC,TRANSPARENT);	
		SetTextColor(hBufDC,RGB(255,255,255));
		
		TextOut(hBufDC,leftTopX-textMet.tmAveCharWidth*3
			,leftTopY+frameHeight+2+(+8+frameHeight+2)*(waveChn-1)+4,"Hz",2);
		
		iy=0;

		// ĝݕ
		if(bLogX) dFreq = 100;
		else dFreq = waveRate < 44100 ? 500 : 1000;  
		
		for(i=0; i < (int) waveRate/2 ; i+=dFreq){
			
			wsprintf(str,"%5d", i);
			
			if(bLogX){ // ΐ
				ix = leftTopX + (DWORD)( log10((double)i)/log10(waveRate/2.) *  frameWidth);
				if(i >= 500) dFreq = 500;
				if(i >= 2000) dFreq = 1000;
				if(i >= 4000) dFreq = 4000;
			}
			else{ // jA
				ix = leftTopX + (DWORD)((double)i/(waveRate/2.)* frameWidth);
			}
			
			// l`
            TextOut(hBufDC,
				ix-(DWORD)((double)textMet.tmAveCharWidth*(2.5+1.5*(i==0))),
				leftTopY+frameHeight+2+4+(8+frameHeight+2)*(waveChn-1)
				+iy*textMet.tmHeight,str,strlen(str)); 
			
			iy = 1-iy;
			
			// ڐ
			hOldPen = (HPEN)SelectObject(hBufDC,GetStockObject(WHITE_PEN));
			for(i2=0;i2<waveChn;i2++){
				MoveToEx(hBufDC,ix,leftTopY+frameHeight+(2+8+frameHeight)*i2+1,NULL); 
				LineTo(hBufDC,ix,leftTopY+frameHeight+(2+8+frameHeight)*i2+4); 
			}
			SelectObject(hBufDC,hOldPen); // XgbNyȂ̂Ńf[gsv
		}
		
		SelectObject(hBufDC,hOldFont);	
		DeleteObject(hFont);
		
		// Ot`	
		
		hPen = CreatePen(PS_SOLID,1,RGB(255,255,0)); 
		hOldPen = (HPEN)SelectObject(hBufDC,hPen);
		
		for(i=0;i<waveChn;i++){ 
			MoveToEx(hBufDC,leftTopX+1,leftTopY+frameHeight+(2+8+frameHeight)*i,NULL);  
			
			// ǓvZ 
			double adAmp , out; 
			adAmp = adjustAmp<=100 ? (double)(101-adjustAmp) : 1/(double)(adjustAmp-99);
			// t[TCY̒
			adAmp *= heightRate2;
			// 摜 Max l킹
			adAmp /= ( dwFftHeight/(DEFAULT_FFTPOINT/4) );
			
			for(i2=0;i2<(int)dwFftHeight;i2++){
				
				if(bLogX){ // gΐXP[
					
					ix = leftTopX + 
						(DWORD)( log10(waveRate/2. * i2 / dwFftHeight)/log10(waveRate/2.) *  frameWidth);
				}
				else{ // jA
					ix = leftTopX + (DWORD)((double)i2 / dwFftHeight * frameWidth);
				}
				
				out = (double)lpdFftData[dwBlockNo*dwFftHeight*i+dwBlockNo*i2+pos];
				if(bLogZ) out = 10*log10(out) - nZbase;
				out *= adAmp;
				
				iy= min((DWORD)(max(out,0)),frameHeight-1);
				
				LineTo(hBufDC,ix,leftTopY+frameHeight+(2+8+frameHeight)*i-iy);   
			}  	
			
		}
		
		SelectObject(hBufDC,hOldPen); 	  
		DeleteObject(hPen);	
		
	}
	
	// ʂRs[
	BitBlt(hDC,0,0,clientWidth,clientHeight,hBufDC,0,0,SRCCOPY);
	
	// ʃobt@J
	DeleteDC(hBufDC);
	DeleteObject(HbBufBit);
	
	// `I
	ReleaseDC(hWnd,hDC);
}


//-------------------------------------------------------------------
// `֐
VOID SeimonPaint(HWND hWnd,DWORD fftPoint,double* lpdFftData,
				 WAVEFORMATEX waveFmt ,DWORD waveDataSize,
				 LPBITMAPINFO  lpBitInfo , HBITMAP hbDIB,
				 HANDLE hdWaveFile,// t@CĂ NULL
				 DWORD childWidth,DWORD childHeight,
				 LONG scrX,LONG scrY, DWORD pos , BOOL boolYAxis,
				 DWORD widthRate,DWORD heightRate,BOOL bLogY,
				 BOOL bGrayScale
				 ){
	
	// `peϐ
	HDC hDC,hMemDC,hBufDC;
	HPEN hPen,hOldPen;
	HBRUSH hOldBrush;
	HFONT hFont,hOldFont;
	TEXTMETRIC textMet; 
    HBITMAP HbBufBit;	 // ʗpobt@
	DWORD vertLine;	// c̈ʒu
	DWORD pos2;	// rbg}bv̎ۂ̃Rs[

	
	RECT rt;
	DWORD clientWidth,clientHeight; 	// NCAg̈̑傫
	double widthRate2,heightRate2; // 摜̊g嗦vZp
	
	DWORD outBitHeight; // rbg}bv̍
	
	// Gpϐ
	LONG i,iy,dFreq;
	CHAR str[CHR_BUF];
	
	//@WAVE ̏
	DWORD  dwFftHeight,dwBlockNo;
	SHORT waveChn,waveBit; 
	LONG  waveRate;
	
	// ۂ̃NCAg̈̑傫擾
	// childWidth,childHeight ͉zIȑ傫
	GetClientRect(hWnd,&rt);
    clientWidth = rt.right-rt.left;
	clientHeight = rt.bottom-rt.top;
	
    // ϐݒ
	waveChn = 2; //`l(_~[p)
	
	if(hdWaveFile != NULL) {
		waveChn = (SHORT)waveFmt.nChannels;	  //`l
		waveRate = (LONG)waveFmt.nSamplesPerSec; // [g
		waveBit = (SHORT)waveFmt.wBitsPerSample; // rbg
		dwBlockNo = waveDataSize/(fftPoint*waveChn*waveBit/8)+1;// vbN 
		dwFftHeight = fftPoint/2;	 // FFT f[^̍ (1 `l) 							   
		outBitHeight = lpBitInfo->bmiHeader.biHeight;  //  bitmap ̍
		outBitHeight-= 30; // t@C񕪂͈̍
	}
	
	// t[̑傫AʒuvZ
	// scrX,scrY  z`̈(childWidth,childHeight)
	// (ۂ)NCAg̈(clientWidth,clientHeight) ɑ΂ʒu
	DWORD frameWidth = DEFAULT_FFTPOINT/2*widthRate;  // g@1 ̓̕
	DWORD frameHeight = DEFAULT_FFTPOINT/2*heightRate;  // g@1 ̓̍
	DWORD leftTopX = (childWidth-(frameWidth+2+(8+frameWidth+2)*(waveChn-1)))/2 +scrX ; // g̍@́@x  W
	DWORD leftTopY = (childHeight-(frameHeight+2))/2 +scrY; //  ́@y W
	
	// \摜̊g嗦̌vZ(t[̕ / f[^)
	// widthRate  1 ̎
	// 256 _̎ 128 _f[^ǂݍ frameWidth = 256 _
	// x2 ƂȂBl 512 _̎ x1 A 1024 _ x1/2 , 2048 _ x1/4
	widthRate2 = (double)frameWidth/((double)fftPoint/2);
	
	// cg嗦  (t[̕ / f[^)
	heightRate2 = (double)frameHeight/((double)fftPoint/2);
	
	// `Jn 
	hDC = GetDC(hWnd);
	
	// ʃobt@̍쐬
	HbBufBit = CreateCompatibleBitmap(hDC,clientWidth,clientHeight);
	hBufDC = CreateCompatibleDC(hDC);
    SelectObject(hBufDC,HbBufBit);
	
	// wi
	if(!bGrayScale || hdWaveFile == NULL){
		hOldPen = (HPEN)SelectObject(hBufDC,GetStockObject(NULL_PEN));
		hOldBrush = (HBRUSH)SelectObject(hBufDC,GetStockObject(BLACK_BRUSH));
	}
	else
	{
		hOldPen = (HPEN)SelectObject(hBufDC,GetStockObject(NULL_PEN));
		hOldBrush = (HBRUSH)SelectObject(hBufDC,GetStockObject(WHITE_BRUSH));
	}
	Rectangle(hBufDC,-1,-1,clientWidth+2,clientHeight+2);
	SelectObject(hBufDC,hOldPen);
	SelectObject(hBufDC,hOldBrush);
	
	// t[`	
	if(!bGrayScale || hdWaveFile == NULL){
		hPen = CreatePen(PS_SOLID,1,RGB(255,255,255));
		hOldPen = (HPEN)SelectObject(hBufDC,hPen);
		hOldBrush = (HBRUSH)SelectObject(hBufDC,GetStockObject(NULL_BRUSH));
	}
	else{
		hPen = CreatePen(PS_SOLID,1,RGB(0,0,0));
		hOldPen = (HPEN)SelectObject(hBufDC,hPen);
		hOldBrush = (HBRUSH)SelectObject(hBufDC,GetStockObject(NULL_BRUSH));
	}
	
	// 
	Rectangle(hBufDC,leftTopX,leftTopY,leftTopX+frameWidth+2,leftTopY+frameHeight+2);
	// E
	if(waveChn==2) Rectangle(hBufDC,leftTopX+frameWidth+2+8,leftTopY,
		leftTopX+frameWidth+2+8+frameWidth+2,leftTopY+frameHeight+2);
	
	SelectObject(hBufDC,hOldPen);
	DeleteObject(hPen);
	SelectObject(hBufDC,hOldBrush);
	
	if(hdWaveFile == NULL){	  // t@CĂ
		
		// tHgݒ
		hFont=CreateFont(24,0,0,0,FW_NORMAL,FALSE,FALSE,FALSE,SHIFTJIS_CHARSET
			,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
			FIXED_PITCH|FF_MODERN,"lr ");
		hOldFont = (HFONT)SelectObject(hBufDC,hFont);	
		
		// gbN擾
		GetTextMetrics(hBufDC,&textMet);
		
		// `
		SetBkMode(hBufDC,TRANSPARENT);			 
        SetTextColor(hBufDC,RGB(255,255,0)) ;
		TextOut(hBufDC,leftTopX+(frameWidth-textMet.tmAveCharWidth*4)/2
			,leftTopY+(frameHeight-textMet.tmHeight)/2,"LEFT",4);
		TextOut(hBufDC,leftTopX+frameWidth+2+8+(frameWidth-textMet.tmAveCharWidth*5)/2
			,leftTopY+(frameHeight-textMet.tmHeight)/2,"RIGHT",5);
		
		SelectObject(hBufDC,hOldFont);			  
		DeleteObject(hFont);
	}
	else{ 	 // t@CJĂ

		// ڐ`
		// tHgI
		hFont=CreateFont(10,0,0,0,FW_NORMAL,FALSE,FALSE,FALSE,SHIFTJIS_CHARSET
			,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, 
			FIXED_PITCH|FF_MODERN,"lr ");		
		hOldFont = (HFONT)SelectObject(hBufDC,hFont);	 
		GetTextMetrics(hBufDC,&textMet);	   
		SetBkMode(hBufDC,TRANSPARENT);	
		if(!bGrayScale)
			SetTextColor(hBufDC,RGB(255,255,255));
		else
			SetTextColor(hBufDC,RGB(0,0,0));

		TextOut(hBufDC,leftTopX-textMet.tmAveCharWidth*3
			,leftTopY-textMet.tmHeight-5,"Hz",2);

		// ĝݕ
		if(bLogY) dFreq = 100;
		else dFreq = waveRate < 44100 ? 500 : 1000;  
		
		for(i=0; i <= (int) waveRate/2 ; i+=dFreq){
			
			wsprintf(str,"%5d", i);
			
			if(bLogY){ // ΐ
				iy = leftTopY +frameHeight 
					-(DWORD)( log10((double)i)/log10(waveRate/2.) *  frameHeight);
				if(i >= 500) dFreq = 500;
				if(i >= 2000) dFreq = 1000;
				if(i >= 4000) dFreq = 4000;
			}
			else{ // jA
				iy = leftTopY +frameHeight 
					-(DWORD)((double)i/(waveRate/2.)* frameHeight);
			}
			
			// l`
			TextOut(hBufDC,leftTopX-textMet.tmAveCharWidth*5-5,
				iy-(DWORD)((double)textMet.tmHeight*(0.5+0.5*(i==0)))
				,str,strlen(str));			
			
			// ڐ
			hOldPen = (HPEN)SelectObject(hBufDC,GetStockObject(WHITE_PEN));
			MoveToEx(hBufDC,leftTopX-1,iy,NULL); 
			LineTo(hBufDC,leftTopX-4,iy ); 
			SelectObject(hBufDC,hOldPen); // XgbNyȂ̂ō폜ȂĂ悢
		}
		
		SelectObject(hBufDC,hOldFont);	
		DeleteObject(hFont);
		
		// rbg}bṽRs[ x W̌vZ
		if(pos < fftPoint/2 /2){
			pos2 = 0;	 
			vertLine = pos;	
		}	  
		else if(pos-fftPoint/2 /2 <= (lpBitInfo->bmiHeader.biWidth-60)-fftPoint/2){ 
			pos2 = pos-fftPoint/2/2;
			vertLine = fftPoint/2/2;
		}
		else {
			pos2 = (lpBitInfo->bmiHeader.biWidth-60)-fftPoint/2;
			vertLine = fftPoint/2 - ((lpBitInfo->bmiHeader.biWidth-60)-pos);
		}
		
		//  DC@̍쐬
		hMemDC = CreateCompatibleDC(hDC);
		SelectObject(hMemDC, hbDIB);
		
		for(i=0;i<waveChn;i++){	
			
			// Bitmap Rs[
			StretchBlt(hBufDC,leftTopX+1+(frameWidth+2+8)*i,leftTopY+1,
				frameWidth,frameHeight,	  
				hMemDC,pos2+50,outBitHeight/2*i+5,fftPoint/2,fftPoint/2,SRCCOPY); 
			
			// Ԏ\
			if(boolYAxis){	
				if(!bGrayScale)
					hPen = CreatePen(PS_SOLID,1,RGB(255,255,0)); 
				else
					hPen = CreatePen(PS_SOLID,1,RGB(255,0,0)); 
				hOldPen = (HPEN)SelectObject(hBufDC,hPen);  	 
				MoveToEx(hBufDC,
					leftTopX+1+(DWORD)((double)vertLine*widthRate2)+(frameWidth+10)*i,
					leftTopY+1,NULL);  
				LineTo(hBufDC,
					leftTopX+1+(DWORD)((double)vertLine*widthRate2)+(frameWidth+10)*i,
					leftTopY+1+frameHeight);					
				SelectObject(hBufDC,hOldPen); 
				DeleteObject(hPen);	
			} 
		}
		
		//  DC ̍폜
		DeleteDC(hMemDC);
	}
	
	// ʂRs[
	BitBlt(hDC,0,0,clientWidth,clientHeight,hBufDC,0,0,SRCCOPY);
	
	// ʃobt@J
	DeleteDC(hBufDC);
	DeleteObject(HbBufBit);
	
	// `I
	ReleaseDC(hWnd,hDC);
	
}


//-------------------------------------------------------------------
// g``֐
VOID HakeiPaint(HWND hWnd,DWORD fftPoint
				,WAVEFORMATEX waveFmt ,
				DWORD waveDataOffset,
				DWORD waveDataSize,
				HANDLE hdWaveFile, // t@CĂȂ NULL
				DWORD childWidth,DWORD childHeight,
				LONG scrX,LONG scrY, DWORD pos){
	
	// `peϐ
	HDC hDC,hBufDC;
	HPEN hPen,hOldPen;	
	HBRUSH hOldBrush;
	HFONT hFont,hOldFont;
	TEXTMETRIC textMet; 
    HBITMAP HbBufBit;	 // ʗpobt@
	
	RECT rt;
	DWORD clientWidth,clientHeight; // NCAg̈̑傫
	
	double widthRate2; //,heightRate2; // 摜̊g嗦vZp
	LONG step;  // f[^o
	
	// ۂ̃NCAg̈̑傫擾
	// childWidth,childHeight ͉zIȑ傫
	GetClientRect(hWnd,&rt);
    clientWidth = rt.right-rt.left;
	clientHeight = rt.bottom-rt.top;
	
	//@WAVE ̏
	SHORT waveChn,waveBit; 
	LONG  waveRate;
	LONG waveLevel[2]; // ̓x
	DWORD readPos; // t@Cǂݍ݈ʒu
	static BYTE waveBuf[MAX_FFTPOINTALIGN]; // f[^ǂݍݗpobt@
	DWORD readByte,dwByte; // ǂݍݗp
	
	// Gpϐ
	LONG i;
	DWORD ix,iy[2],prevY[2];
	
	// ϐݒ	  
	waveChn=2; // `l(_~[)
	
	if(hdWaveFile != NULL){
		waveChn = (SHORT)waveFmt.nChannels;	 // `l
		waveRate = (LONG)waveFmt.nSamplesPerSec; // [g
		waveBit = (SHORT)waveFmt.wBitsPerSample; // rbg
	}
	
	// t[̑傫AʒuvZ
	// scrX,scrY  z`̈(childWidth,childHeight)
	// (ۂ)NCAg̈(clientWidth,clientHeight) ɑ΂ʒu
	DWORD frameWidth = DEFAULT_FFTPOINT; // g@1 ̓̕
	DWORD frameHeight = DEFAULT_FFTPOINT/4;  // g@1 ̓̍
	DWORD leftTopX = (childWidth-(frameWidth+2))/2 + scrX ; // g̍@́@x W
	DWORD leftTopY = (childHeight-(frameHeight+2)-(8+frameHeight+2)*(waveChn-1))/2 +scrY; //  ́@y W
	
	// f[^̎擾̌vZ (f[^/t[̕)
	// widthRate  1 ̎
	// 256 _  1 f[^   512 _  1 f[^   
	// 1024 _  2 f[^   2048 _  4 f[^   
    step = fftPoint/frameWidth;
	if(step == 0) step = 1;
	
	// \摜̊g嗦̌vZ(t[̕ / f[^)
	// widthRate  1 ̎
	// 256 _̎ frameWidth = 512 _
	// x2 ƂȂBl 512 _̎ x1 A 1024 _ x1/2 , 2048 _ x1/4
	widthRate2 = (double)frameWidth/(double)fftPoint;
	
	// `Jn 
	hDC = GetDC(hWnd);
	
	// ʃobt@̍쐬
	HbBufBit = CreateCompatibleBitmap(hDC,clientWidth,clientHeight);
	hBufDC = CreateCompatibleDC(hDC);
    SelectObject(hBufDC,HbBufBit);
	
	// wi
	hOldPen = (HPEN)SelectObject(hBufDC,GetStockObject(NULL_PEN));
    hOldBrush = (HBRUSH)SelectObject(hBufDC,GetStockObject(BLACK_BRUSH));
	Rectangle(hBufDC,-1,-1,clientWidth+2,clientHeight+2);
	SelectObject(hBufDC,hOldPen);
	SelectObject(hBufDC,hOldBrush);
	
	// t[`	
	hPen = CreatePen(PS_SOLID,1,RGB(255,255,255));
	hOldPen = (HPEN)SelectObject(hBufDC,hPen);
	hOldBrush = (HBRUSH)SelectObject(hBufDC,GetStockObject(NULL_BRUSH));
	
	// 
	Rectangle(hBufDC,leftTopX,leftTopY,leftTopX+frameWidth+2,leftTopY+frameHeight+2);
	// E
	if(waveChn==2)
		Rectangle(hBufDC,leftTopX,leftTopY+frameHeight+2+8,
		leftTopX+frameWidth+2,leftTopY+frameHeight+2+8+frameHeight+2);
	
	SelectObject(hBufDC,hOldPen);
	DeleteObject(hPen);
	SelectObject(hBufDC,hOldBrush);
	
	if(hdWaveFile == NULL){	  // t@CĂ
		
		// tHgݒ
		hFont=CreateFont(24,0,0,0,FW_NORMAL,FALSE,FALSE,FALSE,SHIFTJIS_CHARSET
			,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,
			FIXED_PITCH|FF_MODERN,"lr ");
		hOldFont = (HFONT)SelectObject(hBufDC,hFont);	
		
		// gbN擾
		GetTextMetrics(hBufDC,&textMet);
		
		// `
		SetBkMode(hBufDC,TRANSPARENT);			 
        SetTextColor(hBufDC,RGB(255,255,0)) ;
		TextOut(hBufDC,leftTopX+(frameWidth-textMet.tmAveCharWidth*4)/2
			,leftTopY+(frameHeight-textMet.tmHeight)/2,"LEFT",4);
		TextOut(hBufDC,leftTopX+(frameWidth-textMet.tmAveCharWidth*5)/2
			,leftTopY+frameHeight+2+8+(frameHeight-textMet.tmHeight)/2,"RIGHT",5);
		
		SelectObject(hBufDC,hOldFont);			  
		DeleteObject(hFont);
		
	}
	else{ 	 // t@CJĂ
		
		// ǂݍ݈ʒuvZ
		readPos = pos*fftPoint*waveFmt.nBlockAlign;
		SetFilePointer(hdWaveFile, waveDataOffset+readPos, 0, FILE_BEGIN);
		
		// f[^ǂݍ݃TCYvZ
		readByte = (readPos + fftPoint*waveFmt.nBlockAlign ) > waveDataSize 
			? waveDataSize - readPos : fftPoint*waveFmt.nBlockAlign;
		
		// f[^ǂݍ
		ReadFile(hdWaveFile,waveBuf,readByte,&dwByte, NULL);
		
		for(i=0;i<waveChn;i++){ 
			
			// `
			hOldPen = (HPEN)SelectObject(hBufDC,GetStockObject(WHITE_PEN));
			MoveToEx(hBufDC,leftTopX+1,leftTopY+frameHeight/2+(2+8+frameHeight)*i,NULL); 
			LineTo(hBufDC,leftTopX+1+frameWidth,leftTopY+frameHeight/2+(2+8+frameHeight)*i); 
			SelectObject(hBufDC,hOldPen); // XgbNyȂ̂Ńf[gsv
		}
		
		// Ot`	
		hPen = CreatePen(PS_SOLID,1,RGB(255,255,0)); 
		hOldPen = (HPEN)SelectObject(hBufDC,hPen);
		
		for(ix=0;ix<readByte/waveFmt.nBlockAlign;ix+=step){
			
			// o͒lvZ
			WaveLevel(&waveLevel[0],&waveLevel[1],waveBuf+ix*waveFmt.nBlockAlign,waveFmt);
			
			for(i=0;i<waveChn;i++){ 
				
				iy[i] =	(DWORD)((double)waveLevel[i]/(double)((LONG)1 << (waveFmt.wBitsPerSample-1))*frameHeight/2);
				
				if(ix==0) prevY[i] = leftTopY+frameHeight/2+(2+8+frameHeight)*i-iy[i];
				
				MoveToEx(hBufDC,leftTopX+1+(DWORD)((double)ix*widthRate2),prevY[i],NULL); 
				prevY[i] = leftTopY+frameHeight/2+(2+8+frameHeight)*i-iy[i];
				LineTo(hBufDC,leftTopX+1+(DWORD)((double)(ix+step)*widthRate2),prevY[i]);   
			}			
		}  
		
	}
	
	SelectObject(hBufDC,hOldPen); 	  
	DeleteObject(hPen);	
	
	// ʂRs[
	BitBlt(hDC,0,0,clientWidth,clientHeight,hBufDC,0,0,SRCCOPY);
	
	// ʃobt@J
	DeleteDC(hBufDC);
	DeleteObject(HbBufBit);
	
	// `I
	ReleaseDC(hWnd,hDC);
}

//----------------------------------------------------
// 256 F rbg}bv  BITMAPINFO Zbg
BOOL Set8bitDibInfo(LPBITMAPINFO*  lppBitInfo, 
				   LPBYTE* lppBitBuf,
				   DWORD dwWidth,  // 
				   DWORD dwHeight,  // 
				   BOOL bMono // mǂ
				   ){

	int i;

	//  4 ̔{łȂȂ false
	if(dwWidth % 4 != 0) return FALSE;

	// m	
	*lppBitBuf=(LPBYTE)GlobalAlloc(GPTR,
		sizeof(BITMAPINFO)+sizeof(RGBQUAD)*(256-1));

	if(*lppBitBuf==NULL) return FALSE;
		
	*lppBitInfo=(LPBITMAPINFO)(*lppBitBuf);
	
	// CtH\̐ݒ  
	(*lppBitInfo)->bmiHeader.biSize=sizeof(BITMAPINFOHEADER); 
	(*lppBitInfo)->bmiHeader.biWidth=dwWidth;    
	(*lppBitInfo)->bmiHeader.biHeight=dwHeight;            
	(*lppBitInfo)->bmiHeader.biPlanes=1;                     
	(*lppBitInfo)->bmiHeader.biBitCount=8;            // 256 F      
	(*lppBitInfo)->bmiHeader.biCompression=BI_RGB;	// 񈳏k
	(*lppBitInfo)->bmiHeader.biSizeImage=dwWidth*dwHeight; 
	(*lppBitInfo)->bmiHeader.biXPelsPerMeter=0;
	(*lppBitInfo)->bmiHeader.biYPelsPerMeter=0;
	(*lppBitInfo)->bmiHeader.biClrUsed=0;
	(*lppBitInfo)->bmiHeader.biClrImportant=0;
	
	// RGB l ݒ
	if(!bMono){
		for(i=0;i<256;i++){
			(*lppBitInfo)->bmiColors[i].rgbBlue = SetMyColor(i,ID_BLUE);
			(*lppBitInfo)->bmiColors[i].rgbGreen = SetMyColor(i,ID_GREEN);
			(*lppBitInfo)->bmiColors[i].rgbRed = SetMyColor(i,ID_RED);
			(*lppBitInfo)->bmiColors[i].rgbReserved = 0;
		}
	}
	else{
		
		for(i=0;i<256;i++){
			(*lppBitInfo)->bmiColors[i].rgbBlue = 255-i;
			(*lppBitInfo)->bmiColors[i].rgbGreen = 255-i;
			(*lppBitInfo)->bmiColors[i].rgbRed = 255-i;
			(*lppBitInfo)->bmiColors[i].rgbReserved = 0;
		}
	}


	return TRUE;
}




//-------------------------------------------------------------------
// F̐ݒ֐
BYTE SetMyColor(LONG i,WORD colorID){
	WORD retVal;		
	WORD width = 32;
	
	switch(colorID){
	case ID_BLUE:
		if(i==0) retVal=0;
		else if(i<width) retVal = 255*i/width;
		else if(i<width*3) retVal = 255;
		else if(i<width*4) retVal = 255-255*(i-width*3)/width;
		else retVal = 0;
		break;
		
	case ID_GREEN:	
		if(i<width) retVal = 0; 
		else if(i<width*3) retVal = 255*(i-width)/width/2;
		else if(i<width*5) retVal = 255;
		else if(i<width*7) retVal = 255-255*(i-width*5)/width/2;
		else retVal = 0;
		break;
		
	case ID_RED:	
		if(i<width*4) retVal = 0;  
		else if(i<width*5) retVal = 255*(i-width*4)/width; 
		else retVal = 255;
		break;
	}
	
	return((BYTE)retVal);
}



//-------------------------------------------------------------------
// 摜t@Cۑ֐
BOOL SaveBitmap(HWND hWnd , LPSTR lpszSaveFileName,				
				LPBYTE lpBitBuf,LPBITMAPINFO  lpBitInfo, LPBYTE lpBit){
	
	HANDLE hdFile;
	DWORD dwByte; 											
	DWORD outBitWidth,outBitHeight;
	
	// ϐݒ	 
	outBitWidth = lpBitInfo->bmiHeader.biWidth;	 // bitmap̕ @
	outBitHeight = lpBitInfo->bmiHeader.biHeight; // bitmap 
	
	hdFile = CreateFile(lpszSaveFileName,GENERIC_WRITE, 0, 0,
		CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL); 
	if(hdFile == INVALID_HANDLE_VALUE) {  
		MessageBox(hWnd, "ۑł܂B",
			"G[", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);	
		return FALSE;
	}
	else{
		//@wb_ݒ
		BITMAPFILEHEADER bitFileHead;
		
		bitFileHead.bfType=0x4D42;
		bitFileHead.bfSize 
			= sizeof(BITMAPFILEHEADER)
			+sizeof(BITMAPINFO)+sizeof(RGBQUAD)*(256-1)+outBitWidth*outBitHeight;
		bitFileHead.bfReserved1 = 0;
		bitFileHead.bfReserved2 = 0;
		bitFileHead.bfOffBits = 
			sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFO)+sizeof(RGBQUAD)*(256-1);
		
		// 
		WriteFile(hdFile, &bitFileHead,sizeof(BITMAPFILEHEADER), &dwByte, NULL);
		WriteFile(hdFile, lpBitBuf,sizeof(BITMAPINFO)+sizeof(RGBQUAD)*(256-1),&dwByte, NULL);
		WriteFile(hdFile, lpBit,outBitWidth*outBitHeight,&dwByte, NULL);
		// t@CN[Y
		CloseHandle(hdFile);	 	
	}	 
	return TRUE;
}



//-------------------------------------------------------------------
// 摜t@CRs[֐
BOOL CopyBitmap(HWND hWnd , LPBYTE lpBitBuf,LPBITMAPINFO  lpBitInfo, LPBYTE lpBit){
	
	HGLOBAL hGlobal; 
	LPBYTE lpByte;
	DWORD outBitWidth,outBitHeight;
	
	// ϐݒ	 
	outBitWidth = lpBitInfo->bmiHeader.biWidth;	 // bitmap̕ @
	outBitHeight = lpBitInfo->bmiHeader.biHeight; // bitmap 
	
	// m
	hGlobal = GlobalAlloc(GHND,
		outBitWidth*outBitHeight+sizeof(BITMAPINFO)+sizeof(RGBQUAD)*(256-1));
	
	if(hGlobal == NULL) {  
		MessageBox(hWnd, "̊mۂɎs܂B", 
			"G[", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);	
		return FALSE;
	}
	else{
		// ̃bN
		lpByte = (LPBYTE)GlobalLock(hGlobal);
		if(lpByte == NULL) {  
			MessageBox(hWnd, "̃bNo܂B",
				"G[", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);	
			return FALSE;  
		}
		// Rs[
		DWORD i;
		for(i=0;i<sizeof(BITMAPINFO)+sizeof(RGBQUAD)*(256-1);i++)
			lpByte[i] = (BYTE)lpBitBuf[i];
		for(i=0;i<outBitWidth*outBitHeight;i++)
			lpByte[i+sizeof(BITMAPINFO)+sizeof(RGBQUAD)*(256-1)] = (BYTE)lpBit[i];
		
		// ̃AbN
		GlobalUnlock(hGlobal);
		
		// Nbv{[h̃I[v
		if(OpenClipboard(hWnd) == 0){ 
			MessageBox(hWnd, "Nbv{[hJ܂B",
				"G[", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);	
			if(GlobalFree(hGlobal)!=NULL)
				MessageBox(hWnd, "̊JɎs܂B", 
				"G[", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);
			return FALSE;  
		}
		
		EmptyClipboard(); // ɂ
		
		// f[^Zbg
		if(SetClipboardData(CF_DIB,hGlobal)==NULL){  
			MessageBox(hWnd, "Rs[o܂B", 
				"G[", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);
			if(GlobalFree(hGlobal)!=NULL)
				MessageBox(hWnd, "̊JɎs܂B", 
				"G[", MB_OK|MB_SETFOREGROUND|MB_ICONERROR);
			CloseClipboard();
			return FALSE;  
		}
		
		// N[Y
		CloseClipboard();
	}
	
	return TRUE;
}



//-------------------------------------------------------------------
// Q[W`
VOID DrawScale(HWND hWnd,
			   DWORD dwFftPoint,
			   WAVEFORMATEX waveFmt,
			   DWORD dwWaveDataSize,
			   LPBITMAPINFO  lpBitInfo,
			   BOOL bLogY,

			 HBITMAP hbDIB,
			DWORD dwFileSize,
			 BOOL bMono,
			LPSTR lpszFileName
/*
			   LPBITMAPINFO  lpBitInfo,
					 WAVEFORMATEX waveFmt,
			   DWORD dwWaveDataSize,
						DWORD waveTime,
						DWORD fileSize,
						DWORD dwFftPoint,
						BOOL bLogY,
						BOOL bMono,
						LPSTR lpszFileName
*/						
						){
/*
VOID SetBitmap(HWND hWnd,
			   DWORD dwFftPoint,
			   DWORD dwAdjustAmp, 
			   double* lpdFftData, // FFT ̃f[^
			   WAVEFORMATEX waveFmt,
			   DWORD dwWaveDataSize,
			   LPBITMAPINFO  lpBitInfo,
			   LPBYTE lpBit,  // 摜f[^
			   BOOL bLogY,
			   BOOL bLogZ,LONG nZbase
*/

	// 摜peϐ
	HDC hDC,hMemDC;	
	HPEN hPen,hOldPen;
	HFONT hFont,hOldFont;
	TEXTMETRIC textMet; 
	// Gp
	LONG i,i2,ix,iy,dFreq; 
	double di,ddi; 
	CHAR str[CHR_BUF];
	
	DWORD dwWaveTime;
	WORD wWaveChn,wWaveBit;  
	DWORD dwWaveRate;
	DWORD dwOutBitWidth,dwOutBitHeight;  // bitmap A
	DWORD dwFftHeight; // FFT f[^̍
	DWORD dwBlockNo; // ubN
	
	// ϐݒ	
	wWaveChn = (WORD)waveFmt.nChannels; 
	wWaveBit = (WORD)waveFmt.wBitsPerSample; 
	dwWaveRate = (DWORD)waveFmt.nSamplesPerSec;
	
	// t
	dwWaveTime = (DWORD)((double)(dwWaveDataSize)/(double)waveFmt.nAvgBytesPerSec*1000);

	// bitmap ̍B
	dwOutBitHeight = lpBitInfo->bmiHeader.biHeight;
	
	// bitmap ̕
	dwOutBitWidth = lpBitInfo->bmiHeader.biWidth;  

	// vbN
	dwBlockNo = dwWaveDataSize/(dwFftPoint*wWaveChn*wWaveBit/8)+1;  
	dwFftHeight = dwFftPoint/2;		// FFT f[^̍ (1 `lj

	// DC 擾
	hDC = GetDC(hWnd);

	//  DC ̍쐬
	hMemDC = CreateCompatibleDC(hDC);
	SelectObject(hMemDC,hbDIB);
	
	// rbg}bv̖ڐ`
	i = 255*(!bMono);
	hPen = CreatePen(PS_SOLID,1,RGB(i,i,i));
	hOldPen = (HPEN)SelectObject(hMemDC,hPen);
	SelectObject(hMemDC,GetStockObject(NULL_BRUSH));
	
	// tHgI
	hFont=CreateFont(10,0,0,0,FW_NORMAL,FALSE,FALSE,FALSE,SHIFTJIS_CHARSET
		,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY, 
		FIXED_PITCH|FF_MODERN,"lr ");		
	hOldFont = (HFONT)SelectObject(hMemDC,hFont);	 
	GetTextMetrics(hMemDC,&textMet);	   
	SetBkMode(hMemDC,TRANSPARENT);	
	i = 255*(!bMono);
	SetTextColor(hMemDC,RGB(i,i,i));

	// t@C`
	CHAR *stereoOrMono[2]={"mono","stereo"};
	CHAR fName[CHR_BUF],fExt[CHR_BUF];

	_splitpath(lpszFileName,NULL,NULL,fName, fExt);	
	wsprintf(str,"%s%s",fName,fExt);  

	if(dwOutBitWidth > 300){
		TextOut(hMemDC,10,dwOutBitHeight-textMet.tmHeight*2-1,str,strlen(str));
		wsprintf(str,"%d byte, %s, %d Hz, %d bit, %d.%03d sec, %d point"
			,dwFileSize,stereoOrMono[wWaveChn-1],dwWaveRate,wWaveBit,
			dwWaveTime/1000,
			dwWaveTime-(dwWaveTime/1000)*1000,
			dwFftPoint);  
		TextOut(hMemDC,10,dwOutBitHeight-textMet.tmHeight*1-1,str,strlen(str));
	}
	else { // ܂Ԃĕ\
		TextOut(hMemDC,10,dwOutBitHeight-textMet.tmHeight*3-1,str,strlen(str));
		wsprintf(str,"%d byte, %s, %d Hz"
			,dwFileSize,stereoOrMono[wWaveChn-1],dwWaveRate);
		TextOut(hMemDC,10,dwOutBitHeight-textMet.tmHeight*2-1,str,strlen(str));
		
		wsprintf(str,"%d bit, %d.%03d sec, %d point"
			,wWaveBit,
			dwWaveTime/1000,
			dwWaveTime-(dwWaveTime/1000)*1000,
			dwFftPoint);
		TextOut(hMemDC,10,dwOutBitHeight-textMet.tmHeight-1,str,strlen(str));
	}

	dwOutBitHeight-= 30; // t@C񕪂͈̍

	// L-R `
	if(wWaveChn == 2){
		TextOut(hMemDC,1,(dwOutBitHeight-textMet.tmHeight)/4,"L",1);
		TextOut(hMemDC,1,(dwOutBitHeight-textMet.tmHeight)/4*3,"R",1);
	}

	
	for(i=0;i<wWaveChn;i++){
		
		// t[`	
		Rectangle(hMemDC,
			49,dwOutBitHeight/2*i+4,
			49+dwOutBitWidth-60+2,dwOutBitHeight/2*i+4+dwFftHeight+2);
		
		//g\
		TextOut(hMemDC,1,dwOutBitHeight/2*i+5,"Hz",2);

		// ĝݕ
		if(bLogY) dFreq = 100;
		else dFreq = dwWaveRate < 44100 ? 500 : 1000;  


		for(i2=0; i2 < (LONG) dwWaveRate/2 ; i2+=dFreq){
			
			wsprintf(str,"%5d", i2);
			
			if(bLogY){  // ΐ
				iy = dwOutBitHeight/2*i+ 5 + dwFftHeight 
					-(DWORD)( log10((double)i2)/log10((double)dwWaveRate/2) *dwFftPoint/2 );
				if(i2 >= 500) dFreq = 500;
				if(i2 >= 2000) dFreq = 1000;
				if(i2 >= 4000) dFreq = 4000;
			}
			else{ // jA
				iy = dwOutBitHeight/2*i+ 5 + dwFftHeight 
					-(DWORD)((double)i2*dwFftPoint/dwWaveRate);
			}
			
			TextOut(hMemDC,50-textMet.tmAveCharWidth*5-5,
				iy-(DWORD)((double)textMet.tmHeight*0.5),str,strlen(str));			

			// ڐ	
			MoveToEx(hMemDC,49,iy,NULL); 
			LineTo(hMemDC,46,iy ); 
		}
		
		// Ԏ`
		TextOut(hMemDC,dwOutBitWidth-textMet.tmAveCharWidth-1,dwOutBitHeight/2*i+dwFftHeight+5,"s",1);
		
		// ڐ̍ݕ̒
		ddi = 0;
		while((DWORD)textMet.tmAveCharWidth*6 >= (DWORD)(ddi*(double)dwWaveRate/dwFftPoint)) 
			ddi+=0.5; //ݕ̌
		
		// bڂ܂ŕ`悷邩
		double waveTime2; //`悷b (Pʂ͕b)
		waveTime2 = dwFftHeight < dwFftPoint/2 ? (double)((dwFftPoint/2-10)*dwFftPoint)/(double)dwWaveRate : (double)dwWaveTime/1000;
		
		for(di = 0;di<=waveTime2;di+=ddi){
			
			// b`
			if(di == 0) wsprintf(str,"%4d",0);
			else wsprintf(str,"%4d.%01.1d",(DWORD)di,(DWORD)((di-(double)(DWORD)di)*10));  	
			
			ix = 50+ (LONG)(di*(double)dwWaveRate/dwFftPoint);
			
			TextOut(hMemDC,ix-textMet.tmAveCharWidth*3,dwOutBitHeight/2*i+dwFftHeight+5+5				
				,str,strlen(str));
			
			// ڐ	
			MoveToEx(hMemDC,ix,dwOutBitHeight/2*i+dwFftHeight+5+1,NULL);	
			LineTo(hMemDC,ix,dwOutBitHeight/2*i+dwFftHeight+5+4); 
		}
	}
	
	// tHg̍폜
	SelectObject(hMemDC,hOldFont);	
	DeleteObject(hFont);
	
	// y̍폜
	SelectObject(hMemDC,hOldPen);
	DeleteObject(hPen);
	
	//  DC J
	DeleteDC(hMemDC);
	
	// `I
	ReleaseDC(hWnd,hDC);
}	





//-------------------------------------------------------------------
// Bitmap ̔zɃf[^֐		
VOID SetBitmap(HWND hWnd,
			   DWORD dwFftPoint,
			   DWORD dwAdjustAmp, 
			   double* lpdFftData, // FFT ̃f[^
			   WAVEFORMATEX waveFmt,
			   DWORD dwWaveDataSize,
			   LPBITMAPINFO  lpBitInfo,
			   LPBYTE lpBit,  // 摜f[^
			   BOOL bLogY,
			   BOOL bLogZ,LONG nZbase,

			   HBITMAP hbDIB,
			DWORD dwFileSize,
			 BOOL bMono,
			LPSTR lpszFileName

			   ){
	
	WORD wWaveChn,wWaveBit;  
	DWORD dwWaveRate;
	DWORD dwOutBitWidth,dwOutBitHeight;  // bitmap A
	DWORD dwFftHeight; // FFT f[^̍
	DWORD dwBlockNo; // ubN
	double dAdAmp; 
	DWORD dwFoo;

	
	// ǓvZ
	dAdAmp = dwAdjustAmp <= 100 ? (double)(101-dwAdjustAmp) : 1/(double)(dwAdjustAmp-99);
	
	// ϐݒ	
	wWaveChn = (WORD)waveFmt.nChannels; 
	wWaveBit = (WORD)waveFmt.wBitsPerSample; 
	dwWaveRate = (DWORD)waveFmt.nSamplesPerSec;
	
	// vbN
	dwBlockNo = dwWaveDataSize/(dwFftPoint*wWaveChn*wWaveBit/8)+1;  
	dwFftHeight = dwFftPoint/2;		// FFT f[^̍ (1 `lj
	
	// bitmap ̍Bt@C񕪂̍(30)͈
	dwOutBitHeight = lpBitInfo->bmiHeader.biHeight - 30;
	
	// bitmap ̕
	dwOutBitWidth = lpBitInfo->bmiHeader.biWidth;  
	
	// (bitmap ̃oCg͍(0,0)Ȃ̂ɒ)
	DWORD dwBitOffset,dwFftOffset;
	dwBitOffset = dwOutBitWidth*30+dwOutBitWidth*20+50; // t@C+]+]
	dwFftOffset = dwBlockNo*dwFftHeight*(wWaveChn-1);
	
	BYTE bFftData[4];
	DWORD dwFftData = (DWORD)bFftData;

	// NA
	memset(lpBit,0,lpBitInfo->bmiHeader.biSizeImage);

	// ڐ`
	DrawScale(hWnd,dwFftPoint,waveFmt,dwWaveDataSize,lpBitInfo,bLogY,hbDIB,dwFileSize,bMono,lpszFileName);

	DWORD i,i2,i3,dwFoo2;
	double out;
	for(i3=0;i3<wWaveChn;i3++){
		
		if(!bLogY){
			// jAXP[
			dwFoo = dwBitOffset;
			dwFoo2 = dwFftOffset;
			for(i=0;i<dwFftHeight;i++){
				for(i2=0;i2<dwBlockNo;i2++){
					out = lpdFftData[dwFoo2+i2];
					if(bLogZ) out = 10*log10(out)-nZbase;
					out *= dAdAmp;
					lpBit[dwFoo+i2] = (BYTE)min(max(out,0),255);
				}
				dwFoo += dwOutBitWidth;
				dwFoo2 += dwBlockNo;
			}
		}
		else
		{
/*
			//ẽf[^NA
			dwFoo = dwBitOffset;
			for(i=0;i<dwFftHeight;i++){
				memset(lpBit+dwFoo,0,dwBlockNo);
				dwFoo += dwOutBitWidth;
			}
*/
			// OXP[
			dwFoo2 = dwFftOffset;
			for(i=0;i<dwFftHeight;i++){
				dwFoo = dwBitOffset+dwOutBitWidth  
					*(DWORD)(log10((double)i*(dwWaveRate/2./dwFftHeight))/log10(dwWaveRate/2.) * dwFftHeight);
				for(i2=0;i2<dwBlockNo;i2++){
					out = lpdFftData[dwFoo2+i2];
					if(bLogZ) out = 10*log10(out)-nZbase;
					out *= dAdAmp;
					lpBit[dwFoo+i2] = (BYTE)min(max(out,0),255);
				}
				dwFoo2 += dwBlockNo;
			}
		}
	
		dwBitOffset += dwOutBitWidth*dwOutBitHeight/2;
		dwFftOffset = 0;
	}
}



//EOF